Subject: bug#59426: 29.0.50; [tree-sitter] Some functions exceed maximum recursion limit

From: Po Lu <[email-masked]>
Date: Mon, 21 Nov 2022 14:40:47 +0800

Yuan Fu <[email-masked]> writes:

> Emacs crashed on a very large C file when c-ts-mode is on, because
> the function building the imenu list tries to walk through the whole
> parse tree, and end up recusing ~10k times because of how deep the parse
> tree is. These recursive functions should have a built-in limit. Does
> Emacs already have some way to determined the max recursion limit on
> each system? Or should we come up with some hard-coded numbers?

We _used_ to have max-specpdl-size, which would act as a limit if the
recursion was surrounded by specbind.

But it was deleted in Emacs 29.  Maybe it should be brought back, for
this and other deeply recursive C functions?